package io.fabric8.openshift.api.model.machineconfig.v1;

import io.fabric8.kubernetes.api.builder.VisitableBuilder;
import java.lang.Object;
import java.lang.Boolean;
public class MachineConfigPoolSpecBuilder extends io.fabric8.openshift.api.model.machineconfig.v1.MachineConfigPoolSpecFluentImpl<io.fabric8.openshift.api.model.machineconfig.v1.MachineConfigPoolSpecBuilder> implements io.fabric8.kubernetes.api.builder.VisitableBuilder<io.fabric8.openshift.api.model.machineconfig.v1.MachineConfigPoolSpec,io.fabric8.openshift.api.model.machineconfig.v1.MachineConfigPoolSpecBuilder>{
  public MachineConfigPoolSpecBuilder() {
    this(false);
  }
  public MachineConfigPoolSpecBuilder(java.lang.Boolean validationEnabled) {
    this(new MachineConfigPoolSpec(), validationEnabled);
  }
  public MachineConfigPoolSpecBuilder(io.fabric8.openshift.api.model.machineconfig.v1.MachineConfigPoolSpecFluent<?> fluent) {
    this(fluent, false);
  }
  public MachineConfigPoolSpecBuilder(io.fabric8.openshift.api.model.machineconfig.v1.MachineConfigPoolSpecFluent<?> fluent,java.lang.Boolean validationEnabled) {
    this(fluent, new MachineConfigPoolSpec(), validationEnabled);
  }
  public MachineConfigPoolSpecBuilder(io.fabric8.openshift.api.model.machineconfig.v1.MachineConfigPoolSpecFluent<?> fluent,io.fabric8.openshift.api.model.machineconfig.v1.MachineConfigPoolSpec instance) {
    this(fluent, instance, false);
  }
  public MachineConfigPoolSpecBuilder(io.fabric8.openshift.api.model.machineconfig.v1.MachineConfigPoolSpecFluent<?> fluent,io.fabric8.openshift.api.model.machineconfig.v1.MachineConfigPoolSpec instance,java.lang.Boolean validationEnabled) {
    this.fluent = fluent; 
    fluent.withConfiguration(instance.getConfiguration()); 
    fluent.withMachineConfigSelector(instance.getMachineConfigSelector()); 
    fluent.withMaxUnavailable(instance.getMaxUnavailable()); 
    fluent.withNodeSelector(instance.getNodeSelector()); 
    fluent.withPaused(instance.getPaused()); 
    this.validationEnabled = validationEnabled; 
  }
  public MachineConfigPoolSpecBuilder(io.fabric8.openshift.api.model.machineconfig.v1.MachineConfigPoolSpec instance) {
    this(instance,false);
  }
  public MachineConfigPoolSpecBuilder(io.fabric8.openshift.api.model.machineconfig.v1.MachineConfigPoolSpec instance,java.lang.Boolean validationEnabled) {
    this.fluent = this; 
    this.withConfiguration(instance.getConfiguration()); 
    this.withMachineConfigSelector(instance.getMachineConfigSelector()); 
    this.withMaxUnavailable(instance.getMaxUnavailable()); 
    this.withNodeSelector(instance.getNodeSelector()); 
    this.withPaused(instance.getPaused()); 
    this.validationEnabled = validationEnabled; 
  }
  io.fabric8.openshift.api.model.machineconfig.v1.MachineConfigPoolSpecFluent<?> fluent;
  java.lang.Boolean validationEnabled;
  public io.fabric8.openshift.api.model.machineconfig.v1.MachineConfigPoolSpec build() {
    MachineConfigPoolSpec buildable = new MachineConfigPoolSpec(fluent.getConfiguration(),fluent.getMachineConfigSelector(),fluent.getMaxUnavailable(),fluent.getNodeSelector(),fluent.getPaused());
    return buildable;
  }
  public boolean equals(java.lang.Object o) {
    if (this == o) return true;
    if (o == null || getClass() != o.getClass()) return false;
    if (!super.equals(o)) return false;
    MachineConfigPoolSpecBuilder that = (MachineConfigPoolSpecBuilder) o;
    if (fluent != null &&fluent != this ? !fluent.equals(that.fluent) :that.fluent != null &&fluent != this ) return false;

    if (validationEnabled != null ? !validationEnabled.equals(that.validationEnabled) :that.validationEnabled != null) return false;
    return true;
  }
  public int hashCode() {
    return java.util.Objects.hash(fluent,  validationEnabled,  super.hashCode());
  }
  
}