package io.fabric8.openshift.api.model.machineconfig.v1;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonProperty;
import io.fabric8.kubernetes.api.builder.Fluent;
import java.util.ArrayList;
import java.lang.String;
import java.util.LinkedHashMap;
import java.util.function.Predicate;
import java.lang.Integer;
import java.lang.Deprecated;
import java.util.Collection;
import java.lang.Object;
import java.util.List;
import java.lang.Boolean;
import java.util.Map;

 /**
  * Generated
  */
public interface MachineConfigSpecFluent<A extends io.fabric8.openshift.api.model.machineconfig.v1.MachineConfigSpecFluent<A>> extends io.fabric8.kubernetes.api.builder.Fluent<A>{
  public A addToConfig(java.lang.String key,java.lang.Object value);
  public A addToConfig(java.util.Map<java.lang.String,java.lang.Object> map);
  public A removeFromConfig(java.lang.String key);
  public A removeFromConfig(java.util.Map<java.lang.String,java.lang.Object> map);
  public java.util.Map<java.lang.String,java.lang.Object> getConfig();
  public <K,V>A withConfig(java.util.Map<java.lang.String,java.lang.Object> config);
  public java.lang.Boolean hasConfig();
  public A addToExtensions(java.lang.Integer index,java.lang.String item);
  public A setToExtensions(java.lang.Integer index,java.lang.String item);
  public A addToExtensions(java.lang.String... items);
  public A addAllToExtensions(java.util.Collection<java.lang.String> items);
  public A removeFromExtensions(java.lang.String... items);
  public A removeAllFromExtensions(java.util.Collection<java.lang.String> items);
  public java.util.List<java.lang.String> getExtensions();
  public java.lang.String getExtension(java.lang.Integer index);
  public java.lang.String getFirstExtension();
  public java.lang.String getLastExtension();
  public java.lang.String getMatchingExtension(java.util.function.Predicate<java.lang.String> predicate);
  public java.lang.Boolean hasMatchingExtension(java.util.function.Predicate<java.lang.String> predicate);
  public A withExtensions(java.util.List<java.lang.String> extensions);
  public A withExtensions(java.lang.String... extensions);
  public java.lang.Boolean hasExtensions();
  public A addNewExtension(java.lang.String arg0);
  public java.lang.Boolean getFips();
  public A withFips(java.lang.Boolean fips);
  public java.lang.Boolean hasFips();
  public A addToKernelArguments(java.lang.Integer index,java.lang.String item);
  public A setToKernelArguments(java.lang.Integer index,java.lang.String item);
  public A addToKernelArguments(java.lang.String... items);
  public A addAllToKernelArguments(java.util.Collection<java.lang.String> items);
  public A removeFromKernelArguments(java.lang.String... items);
  public A removeAllFromKernelArguments(java.util.Collection<java.lang.String> items);
  public java.util.List<java.lang.String> getKernelArguments();
  public java.lang.String getKernelArgument(java.lang.Integer index);
  public java.lang.String getFirstKernelArgument();
  public java.lang.String getLastKernelArgument();
  public java.lang.String getMatchingKernelArgument(java.util.function.Predicate<java.lang.String> predicate);
  public java.lang.Boolean hasMatchingKernelArgument(java.util.function.Predicate<java.lang.String> predicate);
  public A withKernelArguments(java.util.List<java.lang.String> kernelArguments);
  public A withKernelArguments(java.lang.String... kernelArguments);
  public java.lang.Boolean hasKernelArguments();
  public A addNewKernelArgument(java.lang.String arg0);
  public java.lang.String getKernelType();
  public A withKernelType(java.lang.String kernelType);
  public java.lang.Boolean hasKernelType();
  
  /**
   * Method is deprecated. use withKernelType instead.
   */
  @java.lang.Deprecated
  public A withNewKernelType(java.lang.String arg0);
  public java.lang.String getOsImageURL();
  public A withOsImageURL(java.lang.String osImageURL);
  public java.lang.Boolean hasOsImageURL();
  
  /**
   * Method is deprecated. use withOsImageURL instead.
   */
  @java.lang.Deprecated
  public A withNewOsImageURL(java.lang.String arg0);
  
}